<template>
  <div class="about-me">
    <div class="title">About me</div>
    <div class="input-container">
      <div class="inp">
        <div class="label">First Name</div>
        <input maxlength="50" type="text" v-model="firstNameComp" >
      </div>
      <div class="inp">
        <div class="label">Last Name</div>
        <input maxlength="50" type="text" v-model="lastNameComp">
      </div>
    </div>
    <div class="input-container">
      <div class="inp">
        <div class="label">Telephone</div>
        <input maxlength="50" type="text" v-model="telephoneComp">
      </div>
      <div class="inp">
        <div class="label">Last Name</div>
        <input placeholder="Your Avatar" type="file" ref="imageFile" @change="previewFiles" >
      </div>
    </div>
    <div class="btn-cont">
      <div class="btn-save" @click="save">Save</div>
    </div>
  </div>
</template>
<script>
import { PROFILE } from '@/store/types'
import axios from 'axios'
import { mapGetters } from 'vuex'
export default {
  name: 'ProfileAboutMe',
  data: () => ({
    firstName: '',
    lastName: '',
    telephone: '',
    files: []
  }),
  computed: {
    ...mapGetters({
      userData: PROFILE.GETTER.GET_USER_DATA
    }),
    firstNameComp: {
      set (value) {
        this.firstName = value
      },
      get () {
        return this.userData.firstName
      }
    },
    lastNameComp: {
      set (value) {
        this.lastName = value
      },
      get () {
        return this.userData.lastName
      }
    },
    telephoneComp: {
      set (value) {
        this.telephone = value
      },
      get () {
        return this.userData.telephone
      }
    }
  },
  methods: {
    async save () {
      const obj = {
        firstName: this.firstName || this.firstNameComp,
        lastName: this.lastName || this.lastNameComp,
        telephone: this.telephone || this.telephoneComp
      }
      if (this.files[0]) {
        try {
          obj.imageName = this.files && this.files[0] && this.files[0].name
          const formData = new FormData()
          formData.append('imageFile', this.files[0])
          await axios.post('http://localhost:9192/image/upload', formData, { headers: { 'Content-Type': 'multipart/form-data' } })
        } catch (err) {
          console.error('poui', err)
        }
      }
      await this.$store.dispatch(PROFILE.ACTION.UPDATE_PROFILE, obj)

      const userId = this.$store.getters[PROFILE.GETTER.GET_USER_DATA].id
      await this.$store.dispatch(PROFILE.ACTION.LOAD_PROFILE, userId)
    },
    async previewFiles () {
      this.files = this.$refs.imageFile.files
    }
  }
}
</script>
<style lang="scss" scoped>
.about-me {
  width: 100%;

  .title {
    font-size: 24px;
    font-weight: 600;
    text-align: start;
    margin-bottom: 30px;
  }

  .input-container {
    max-width: 100%;
    width: 100%;
    display: flex;
    justify-content: space-between;
    margin-bottom: 20px;;
  }

  .inp {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    max-width: 300px;
    width: 100%;

    .label {
      margin-bottom: 8px;
      font-size: 18px;
    }
    & input {
      border-radius: 6px;
      padding: 5px 8px;
      box-sizing: border-box;
      // max-width: 350px;
      width: 100%;
    }
  }

  .btn-cont {
    display: flex;
    justify-content: flex-end;
    margin-top: 50px;
    width: 100%;
    .btn-save {
      background: #ff6392;
      color: #fff;
      padding: 10px 20px;
      cursor: pointer;
    }
  }
}
</style>
